/* This file is part of Chunky Monkey IRCD 
 *
 * Chunky Monkey IRCD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Chunky Monkey IRCD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Chunky Monkey IRCD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $Id: cmd_names.c,v 1.9.4.4 2002/09/06 19:52:46 lloydy Exp $
 *
 */
#include "modules.h"

CMIRCD_MODULE(1.02, CMD_CLIENT);

/* Sends a name list to a client */
int cmd_names(ClientInfo c_ptr, ServerInfo s_ptr, Cmd cmd)
{
    int i;
    ChannelInfo chan = NULL;
    char buffer[BUF_SIZE];

    /* Only allow local ones */
    if (!c_ptr || s_ptr) {

	return 0;
    }

    if (!cmd->params[0]) {
	/* List everything */
	chan = get_channel_with_mask("*");
	while (chan) {
	    send_namelists(chan, c_ptr);
	    chan = NULL;
	    /* Get next channel with previous mask */
	    chan = get_channel_with_mask(NULL);
	}

	clients_nochan_names(c_ptr, NULL, NULL);

	send_numeric(c_ptr, get_my_server(), 366, "* :End of /NAMES list");

    }

    for (i = 0; i < 14 && cmd->params[i] != NULL; i++) {
	chan = NULL;
	chan = locate_channel(cmd->params[0]);
	if (chan) {
	    send_namelists(chan, c_ptr);
	    ircd_sprintf(buffer, BUF_SIZE,
			 "%s :End of /NAMES list", chan->name);
	    send_numeric(c_ptr, get_my_server(), 366, buffer);
	}
    }


    return 1;
}
